*H SCPGAE.S
;******************************************************************
; Bildschirmtreiber fuer SCP
; Stand: 11.05.89
; Bearbeiter: Gaertner EKR
;
;------------------------------------------------------------------
	external	JPVER5
	external	VHOME
	external	BEEP
	external	KULIFS
	external	VLF
	external	CLSTSC
	external	VCR
	external	CSCRFK
	external	KUREFS
	external	CLINFK
	external	CLIN
	external	KUHO
	external	ESC
	external	WRZEMU
	external	AOUTI4
	external	AOUTI5
	external	SAZLSP
	external	ESCF7
	external	POP0
	external	DEL
	external	TGRASC
	external	CURSRD
	external	CURSS
	external	STWIND
	external	SELSCR
	external	KEYON
	external	KEYOFF
	external	FULL
	external	VFTIN2
	external	VFTIN6
	external	WRMOD
 EXTERNAL	ZG	REZEMU
;==================================================================
	global		ZEISA0	INISCR	PTVRA1	PTVRA2	FEMEIN	FEMAUS
;==================================================================
MONTV	equ	17Dh
PARAP	equ	98h
;==================================================================
;Initialisierung des Bildschirms f}r SCP
;RAM-Zellen init.
;PATCH-Rufe init.
;SCP-Zeichensatz init.
;SCREEN 1 einstellen
;Bildschirm l|schen
;--------------------
INISCR	ld	hl,INISC1
	ld	de,ZEISFL
	ld	bc,4
	ldir			;RAM init
;
	ld	de,XOUASC
	ld	bc,5
	ldir			;PATCH-Ruf
;
	ld	de,XVFTIN
	ld	bc,5
	ldir			;PATCH-Ruf
;
	call	SCPZGI		;Zeichensatz init
;
	ld	hl,STFTA1
	ld	de,FKEY1
	ld	bc,160
	ldir			;Standard-F-Tasten f}r SCP init
;
	xor	a
	call	MONTV		;BS-Modus einstellen (a=0 SCP)
;
	call	KEYOFF
	call	STWIND
	call	CLSTSC		;BS 80*25 l|schen
	call	KEYON
	call	STWIND		;BS 80*24 einstellen Zeile 25 Sonderzeile
	ret
;--------------------------------------------------------------
;Initialisierungswerte
INISC1	defb	7Fh		;ZEISFL
	defb	0		;ZEISA
	defb	0		;INVEFL
	defb	0		;FKTAN1
;
	defb	0CDh		;call
	defw	SCPAOU		;SCPAOU
	defw	0C9C9h		;ret ret
;
	defb	0CDh		;call
	defw	SVFTI0		;SVFTI0
	defw	0C9C9h		;ret ret
;
STFTA1	defm	'dienst'
	defb	0Dh
	defb	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'dir '
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'stat '
	defb	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'type '
	defb	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'go'
	defb	0Dh
	defb	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'tp'
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'dir'
	defb	0Dh
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'ren '
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'pip '
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;
	defm	'user '
	defb	0
	defw	0
	defw	0
	defw	0
	defw	0
	defw	0
;==================================================================
;
;Ausgabe eines Zeichens auf den Bildschirm
;
;Behandlung der Steuerzeichen kompatibel zu SCP und CP/A
;
;IN : a Zeichen
SCPAOU	ld	c,a
	call	TGRASC		;Grafikbildschirm eingestellt?
	ret	nc		;ja -> keine Zeichenausgabe
	ld	hl,SCPAO3
	push	hl		;Ruecksprung aus Routinen kellern
;
	ld	hl,ESCSW
	ld	a,(hl)
	and	a
	jp	nz,ESCFOB	;(ESCSW)<>0 -> ESC-Folge behandeln
;
	ld	a,c		;a Zeichen
	cp	20h		;Steuerzeichen
	jr	c,SCPJPV	;ja ->Steuerzeichenauswertung
;
	ld	hl,(CRSZL)	;hl aktuelle Kursorpos.
	cp	7Fh		;Zeichen= DEL?
	jp	z,DEL		;ja
	jr	nc,SONDER	;Zeichen > 7Fh
;
SCPAO5	ld	a,(ZEISFL)	;a Kennbyte Zeichensatz
	and	a
	jp	p,SCPAO1	;=7Fh
	or	c		;Bit 8 des Zeichens setzen
	jr	SCPAO2
SCPAO1	and	c		;Bit 8 des Zeichens r}cksetzen
	ld	c,a
SCPAO2	call	AOUTI4		;Zeichenausgabe aus ROM-BS rufen
	pop	hl		;R}cksprung zu SCPAO3 unterbinden
SCPAO3	ld	hl,2
	add	hl,sp
	ld	de,POP0		;R}cksprung in 32k-ROM nach AOUTI4
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ret			;R}cksprung in Patch-Ruf
;-----------------------
SCPAO4	ld	a,c
	cp	0A0h
	jr	nc,SCPAO5	;Zeichen>9Fh (druckbare)
	and	7Fh		;Bit 7 ausblenden -> Zeichen 0..1Fh
	jr	SCPJPV	 	;Steuerzeichenauswertung
;===================================================================
;Behandlung der Zeichen 82h...87h
;IN : a Zeichen
SONDER	sub	82h
	jr	z,KUEIN		;Zeichen=82h Kursor ein
	dec	a
	jr	z,KUEIN1	;Zeichen=83h Kursor aus
	dec	a
	cp	4		;Zeichen=84h...87h
	jr	nc,SCPAO4	;nein -> Umwandlung in Zeichen < 80h
;
	rra			;Invers-Bit ins CY
	push	af
;
	ld	c,20h		;Leerzeichen
	call	AOUTI4 	 	;ausgeben
;
	pop	af
	push	af
	jr	c,SONDE1	;Invers
	call	FANORM		;Normal
	jr	SONDE2
SONDE1	call	FAINVE
SONDE2	pop	af
	rra			;Hell-Bit ins CY
	ld	a,(ACTCOL)
	call	HELLDU		;[nderung Farbbyte entspr. CY
	and 	0EFh		;Blinken aus
	ld	(ACTCOL),a
	ret
;
KUEIN	inc	a		;a=1
KUEIN1	jp	ESCF7		;Sprung in 32k-ROM Kursor-ein/aus
;=================================================================
;Berechnung Ansprungadresse der Routine Steuerzeichenbehandlung
; IN : a Steuerzeichen
SCPJPV	ld	hl,SCPSTE-2	;Anfang der Tabelle
	ld	c,14		;Anzahl
	jp	JPVER5		;Sprung in 32k-ROM
;
SCPSTE	defb	1
	defw	VHOME
	defb	7
	defw	BEEP
	defb	8
	defw	KULIFS
	defb	0Ah
	defw	VLF
	defb	0Ch
	defw	CLSTSC
	defb	0Dh
	defw	VCR
	defb	0Eh
	defw	ZEISA1
	defb	0Fh
	defw	ZEISA2
	defb	14h
	defw	CSCRFK
	defb	15h
	defw	KUREFS
	defb	16h
	defw	CLINFK
	defb	18h
	defw	CLIN
	defb	1Ah
	defw	KUHO
	defb	1Bh
	defw	ESC
;==========================================================
;Behandlung der ESC-Folgen
; IN : a (ESCSW)  f entspr.Test (ESCSW)  c Zeichen
ESCFOB	jp	m,ESCFO2	; (ESCSW)>7Fh
	cp	11h
	jp	c,ZEIATA		; (ESCSW) 1...10h
	cp	1Bh
	jp	z,FTNEU		; (ESCSW) 1Bh
	ld	de,ESCFO1
	push	de		;R}ckkehradr. nach Behandlung 5E 5F
	sub	5Eh
	jr	z,ESC5E		;Behandlung ESC 5Eh
	dec	a
	jr	z,ESC5F		;Behandlung ESC 5Fh
ESCFO1	xor	a
	ld	(ESCSW),a	;(ESCSW)=0
	ret
ESCFO2	ld	a,c		;a Zeichen
	and	a
	jp	m,ESCKUP	;Zeichen nach ESC > 7Fh -> Kurs.pos.
	ld	(hl),a		;(ESCSW)=Zeichen
	ret
;=========================================================
;Behandlung Folge ESC 5Eh
; IN : c Zeichen
ESC5E	ld	a,c		;a Zeichen
	cp	40h
	ret	c		;<40h
	cp	48h
	jr	nc,ESC5E1	;>47h
;
	push	bc
	ld	c,20h		;Leerzeichen
	call	AOUTI5		;ausgeben
	pop	bc
;
	call	FANORM		;Einstellung normale Darstellung
	jr	ESC5E2
;
ESC5E1	cp	50h
	ret	c		;47h< Zeichen <50h
	cp	58h
	ret	nc		;>57h
;
	push	bc
	ld	c,20h		;Leerzeichen
	call	AOUTI5		;ausgeben
	pop	bc
;
	call	FAINVE		;Einstellung inverse Darstellung
;
ESC5E2	ld	a,(ACTCOL)
	srl	c		;Hell-Bit in CY
	call	HELLDU		;[nderung Farbbyte entspr. CY
	srl	c		;Blink-Bit in CY
	call	BLINK		;[nderung Farbbyte entspr. CY
	ld	(ACTCOL),a
	srl	c		;Zeichensatz-Bit in CY
	ld	a,7Fh		;Bit 7 = 0  Zeichensatz 1 lokal
	jr	nc,ESC5E3
	inc	a		;Bit 7 = 1  Zeichensatz 2 lokal
ESC5E3	ld	(ZEISFL),a
	ret
;=============================================================
;Behandlung Folge ESC 5Fh
; IN : c  Zeichen
ESC5F	ld	a,c		;a Zeichen
	cp	30h
	jp	z,ZEISA1	;ESC 5Fh 30h  Zeichensatz 1 global
	cp	31h
	jp	z,ZEISA2	;ESC 5Fh 31h  Zeichensatz 2 global
;
	cp	40h
	ret	c		;Zeichen < 44h
	cp	6Ch
	ret	nc		;Zeichen > 6Fh
;
	ld	a,(ACTCOL)
	push	af		;globale Farbe kellern
	srl	c		;Hell-Bit in CY
	call	HELLDU		;[nderung Farbbyte
	srl	c		;Blink-Bit in CY
	call	BLINK		;[nderung Farbbyte
	ld	(ACTCOL),a	;lokales Farbbyte
;
	ld	a,c		;a Zeichen
	sub	0Fh		;Grafikzeichen auf Nr. im ZG
	ld	c,a
	call	AOUTI5
;
	pop	af
	ld	(ACTCOL),a	;globales Farbbyte regenerieren
	ret
;===============================================================
;Kursorpositionierung mit ESC-Folge
; IN : c Zeichen  (ESCSW)=0FFh -> Zeile  (ESCSW)=0FEh -> Spalte
ESCKUP	ld	de,CRSSP
	inc	(hl)
	push	af		;F-Reg. kellern
	jr	nz,ESCKU1	;(ESCSW) war 0FEh
;
	dec	(hl)
	dec	(hl)		;(ESCSW) wird 0FEh
	dec	de		;de Zeiger auf CRSZL
	ld	a,(ZLLAST)
ESCKU0	ld	b,a		;b Grenzwert
	ld	a,c		;a Zeichen
	sub	80h		;Offset abziehen
	cp	b		;Vergleich mit Grenzwert
	inc	a		;Z{hlung 1...
	ld	(de),a		;neue Koordinate laden
	jr	c,ESCKU2	;nicht au~erhalb
	ld	a,b
	ld	(de),a		;Grenzwert annehmen
;
ESCKU2	pop	af
	ret	z		;folgt noch Angabe der Spalte
;
	ld	hl,(CRSZL)
	jp	SAZLSP		;neue Kursorpos. einstellen  32k-ROM
;
ESCKU1	inc	(hl)		;(ESCSW) = 0
	ld	a,(SPLAST)	;Grenzwert Spalte
	jr	ESCKU0
;==========================================================
;Einleiten der Neudefinition einer F-Taste
; IN : c Nummer der Taste
FTNEU	ld	a,c		;a Zeichen
	sub	30h
	cp	0Ah		;Taste 0..9
	ret	nc		;Nr. >9
	ld	h,0
	ld	l,a
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl		;hl  Tastennr. * 16 Byte
	ld	bc,FKEY1
	add	hl,bc		;hl  Anfangsadr. Puffer der F-Taste
	ld	(RAD2),hl	;zwischenspeichern
	ld	a,16
	ld	(ESCSW),a	;max. L{nge
	ret
;===========================================================
;Zeichen in F-Tastenpuffer ablegen
; IN : c Zeichen   a und (ESCSW) verf}gbare L{nge+1
ZEIATA	cp	1
	ld	a,c		;a Zeichen
	jr	z,ZEIAT3	;verf}gbare L{nge 0
	ld	de,(RAD2)
ZEIAT1	ld	(de),a		;Zeichen in Puffer
	inc	de
	dec	(hl)
	dec	(hl)		;(ESCSW)-2
	jr	z,ZEIAT2	;(ESCSW)=0  Puffer voll
	inc	(hl)		;(ESCSW)+1
	and	a
	jr	z,ZEIAT1	;Zeichen war 0 -> Puffer mit 0 f}llen
	ld	(RAD2),de	;Zeiger in Puffer zwischenspeichern
	ret			;weiter zum n{chsten Zeichen
;
ZEIAT2	and	a		;a=0?
	jr	z,ZEIAT4	;ja --> (ESCSW)=0
	inc	(hl)		;(ESCSW)=1
	xor	a
ZEIAT4	ld	(de),a		;0 als Abschlu~ in Puffer
	jr	ZEIAT5		;warten auf 00 oder fertig
;
ZEIAT3	and	a
	ret	nz		;weiter warten auf 00
	ld	(hl),a		;(ESCSW)=0  Abschlu~ ESC-Folge
ZEIAT5	ld	a,0FFh
	ld	(FUFLAG),a	;Anzeige bei IR u. FT-Anzeige ein
	ret
;==============================================================
;Tauschen der Zeichens{tze nach Taste (ALT)
ZEISA0	ld	a,(ZEISA)
	cpl			; 0 -> FF     FF -> 0
	ld	(ZEISA),a	;Kennbyte f}r anderen Zeichensatz
	jr	ZEITAU		;Spezialzeichen tauschen
;Laden der Spezialzeichen f}r 1. Zeichensatz
ZEISA1	ld	hl,ZEISA	;In:  FF      0
	inc	(hl)		;     0       1
	jr	z,ZEITAU	;     X
	dec	(hl)		;             0
	ret			;fertig, war bereits Zeichensatz 1
;
;Laden der Spezialzeichen f}r 2. Zeichensatz
ZEISA2	ld	hl,ZEISA	;In:  FF      0
	inc	(hl)		;     0       1
	jr	nz,ZEISA3	;             X
	dec	(hl)		;     FF
	ret			;fertig, war bereits Zeichensatz 2
;
ZEISA3	dec	(hl)		;             0
	dec	(hl)		;             FF
ZEITAU	ld	h,1Fh      	;erstes zu tauschendes Zeichen-1
ZEITA1	inc	h		;Nr.+1
	ret	m		;Nr.=80h -> fertig
;
	ld	a,h 		;a: Nr.
	call	REZEMU		;Zeichen 1 lesen
	ld	a,h
;
	ld	hl,ZEIPUF
	ld	de,HSWAP
	ld	bc,8
	ldir			;Zeichen1 (8 Byte) umspeichern
;
	ld	h,a		;h: Nr.
	or	80h		;a: Nr.80h
	call	REZEMU		;Zeichen 2 in ZEIPUF
	ld	c,h		;c: Nr.
	ld	e,h
;
	ld	hl,ZEIPUF
	call	WRZEMU		;Zeichen 2 auf Zeichennr.
;
	ld	a,e
	or	80h
	ld	c,a		;c Zeichennr.+80h
	ld	hl,HSWAP
	call	WRZEMU		;Zeichen 1 auf Zeichennr.+ 80h
	ld	h,e		;h: Nr.
	jr	ZEITA1
;-------------------------------------------------------------
ZEIUP0	push	bc
	call	WRZEMU		;8 Byte ab hl in Zeichengen.
	pop	bc
	inc	c		;c n{chste Zeichennr.
	djnz	ZEIUP0
	ret
;=============================================================
;Zeichengenerator initialisieren
; IN : im Zeichengenerator ist RBASIC-Zeichensatz
SCPZGI	ld	hl,ZG+100h	;32*8 Byte
	ld	bc,60A0h	;Zeichen Nr.A0h..FFh
	call	ZEIUP0		;mit Zeichen 20h..7Fh }berschreiben
	ld	hl,GRAZG	;Zeichensatz mit Pseudografik SCP
	ld	bc,0B01h	;Zeichen Nr. 1...0Bh
	call	ZEIUP0
;Laden der Spezialzeichen zwischen 40h und 7Fh
      	ld	c,40h		;Zeichen Nr. 40h
	ld	hl,ZEIADR
	call	WRZEMU
	ld	bc,35Bh		;Nr. DBh..DDh
	call	ZEIUP0
	ld	bc,47Bh		;Nr. FBh...FEh
	jr	ZEIUP0
;
;==============================================================
;Farbdarstellung NORMAL einstellen
; IN : (INVEFL) kennzeichnet aktuellen Farbzustand  0  =normal
;						    FFh=invers
FANORM	ld	a,(INVEFL)
	and	a
	ret	z		;bereits normal
FANOR1	cpl
	ld	(INVEFL),a
	jr	FARBUM
;
;Farbdarstellung INVERS einstellen
; IN : (INVEFL) s.o.
FAINVE	ld	a,(INVEFL)
	and	a
	ret	nz		;bereits invers
	jr	FANOR1
;
;Farbcode umstellen
FARBUM	ld	a,(ACTCOL)
	push	bc
	ld	c,a
	and	18h
	ld	b,a		;b : 0 0 0 Bl He 0 0 0
	ld	a,c
	rlca
	rlca
	rlca			;a : Bl He V V V H H H
	ld	c,a
	and	7
	push	af		;kellern: 0 0 0 0 0 H H H
	ld	a,c
	rlca
	rlca			;a : V V V H H H Bl He
	and	0E0h
	ld	c,a		;c : V V V 0 0 0 0 0
	pop	af
	or	c
	or	b		;a : V V V Bl He H H H
	pop	bc
	ld	(ACTCOL),a
	ret
;=========================================================
;Auswertung Hell/Dunkel
; IN : CY= 0 dunkel
;	 = 1 hell
;      a Farbbyte
; OUT: a Farbbyte
HELLDU	jr	c,HELLD1	;hell
	and	0F7h		;Hell-Bit aus
	ret
HELLD1	or	8		;Hell-Bit ein
	ret
;
;Auswertung Blinken
; IN : CY= 0 blinken aus
;	 = 1    "    ein
;      a Farbbyte
; OUT: a Farbbyte
BLINK	jr	c,BLINK1	;ein
	and	0EFh		;Blink-Bit aus
	ret
BLINK1	or	10h		;Blink-Bit ein
	ret
;=============================================================
;Erweiterung F-Tasten-Initialisierung f}r SCP
;IN: b Anzahl der freien Stellen im VRAM
;    hl Quellpuffer
SVFTI0	ld	a,(ACTCOL)
	push	af		;aktuelle Farbe kellern
	ld	a,(INVEFL)
	and	a		;invers eingestellt ?
	call	z,FARBUM	;nein -> Umschaltung
SVFTI1	call	WRMOD		;GDC in Schreibmodus
	ld	a,(hl)		;Zeichen aus Puffer
	inc	hl
	and	a
	jr	nz,SVFTI4
	ld	a,20h		;0 durch SPACE ersetzen
SVFTI4	cp	20h		;Steuerzeichen
	jr	nc,SVFTI2	;nein
;
	add	a,40h		;a Gro~buchstabe entsprechend CTRL-Code
	push	af		;Zeichen kellern
	ld	a,5Eh		;"^"
	out	(PARAP),a
	call	FULL
	ld	a,(ACTCOL)	;^ in inverser Farbe ausgegeben
	out	(PARAP),a
	pop	af		;Gro~buchstaben regen.
	dec	b
	jr	z,SVFTI3	;F-Taste nach ^ voll
	call	FULL
;
SVFTI2	out	(PARAP),a
	call	FULL
	ld	a,(ACTCOL)
	out	(PARAP),a	;Zeichen bzw. Gro~buchst. f}r Steuerzeichen
				;in inverser Farbe ausgegeben
	djnz	SVFTI1		;F-Taste noch nicht vollst{ndig
;
SVFTI3	ld	hl,4		;F-Taste fertig
	add	hl,sp
	ld	de,VFTIN6
	ld	(hl),e		;Stackmanipulation
	inc	hl
	ld	(hl),d
	ld	e,a
	pop	af
	ld	(ACTCOL),a	;aktuelle Farbe regen.
	ld	a,e		;a lokale Farbe, falls letztes Zeichen folgt
	ret
;===============================================================
;80 Zeichen in VRAM ab FF40h (Sonderzeile ohne SHIFT) }bertragen
;IN  de : Adresse Quellpuffer
PTVRA1	ld	hl,0FF40h
	jr	PTVRA3
PTVRA2	ld	hl,0FF90h
PTVRA3	push	hl
	call	CURSRD		;physischen Kursor lesen
	ex	(sp),hl		;und kellern
	ld	bc,5001h	;80 Zeichen 1Taste
	call	VFTIN2
	pop	hl
	call	CURSS		;physischen Kursor regenerieren
	ret
;========================================================
;Fehlermeldung auf Sonderzeile anzeigen
;IN : de Adresse Quellpuffer Fehlertext
FEMEIN	ld	a,(FZELLE)
	and	a
	ret	nz		;bereits Fehlermeldung auf Zeile
;
	ld	a,100
	ld	(FZELLE),a	;Z{hler f}r Dauer der Anzeige setzen
;
	ld	a,(FKTANZ)
	ld	(FKTAN1),a	;Anzeigemodus vor Fehlermeldung speichern
	push	de
	call	PTVRA1		;Anzeige ab FF40h
	pop	de		;noch einmal gleicher Text
	call	PTVRA2		;Anzeige ab FF90h
	jp	KEYON		;Anzeige ein
;===========================================================
;Fehlermeldung ausschalten
;IN : -
FEMAUS	ld	a,(FKTAN1)
	ld	(FKTANZ),a	;Anzeigemodus vor Fehlermeldung regen.
	and	a
	call	z,KEYOFF	;Anzeige aus falls 0
	xor	a
	ld	(FZELLE),a	;keine Fehlermeldung mehr
	DEC	A
	LD	(STFLAG),A	;Ausgabe anmelden
	LD	(FUFLAG),A
	ret
;=========================================================
;Spezialzeichen
ZEIADR	defw	0638h	;Paragraph
	defw	423Ch
	defw	603Ch
	defw	1Ch
;
	defw	1866h	;[
	defw	663Ch
	defw	667Eh
	defw	66h
;
	defw	1C63h	;\
	defw	6336h
	defw	3663h
	defw	1Ch
;
	defw	66h	;]
	defw	6666h
	defw	6666h
	defw	3Ch
;
	defw	36h	;{
	defw	301Eh
	defw	333Eh
	defw	6Eh
;
	defw	66h	;|
	defw	663Ch
	defw	6666h
	defw	3Ch
;
	defw	66h	;}
	defw	6666h
	defw	6666h
	defw	7Ch
;
	defw	631Eh	;~
	defw	3B63h
	defw	6363h
	defw	031Bh
;
GRAZG	defw	0	;218
	defw	0F800h
	defw	0808h
	defw	0808h
;
	defw	0	;191
	defw	0F00h
	defw	0808h
	defw	0808h
;
	defw	0808h	;192
	defw	0F808h
	defw	0
	defw	0
;
	defw	0808h	;217
	defw	0F08h
	defw	0
	defw	0
;
	defw	0	;194
	defw	0FF00h
	defw	0808h
	defw	0808h
;
	defw	0808h	;180
	defw	0F08h
	defw	0808h
	defw	0808h
;
	defw	0808h	;195
	defw	0F808h
	defw	0808h
	defw	0808h
;
	defw	0808h	;193
	defw	0FF08h
	defw	0
	defw	0
;
	defw	0	;196
	defw	0FF00h
	defw	0
	defw	0
;
	defw	0808h	;179
	defw	0808h
	defw	0808h
	defw	0808h
;
	defw	0808h	;197
	defw	0FF08h
	defw	0808h
	defw	0808h
;=============================
