*H SCPROM1.S
;----------------------------------------------------------
; ROM-Erweiterung fuer SCP
; Stand: 28.03.89
; File: SCPROM1.S
;----------------------------------------------------------
*I 7/ORG.S
*I 7/K4.S
;*I 7/BIC.MAC.S
*L OFF
*I 7/BIC.MAC.S
*L ON
; externals aus ROM-BIOS
DBAABF	equ	138h
PPIA	equ	0A8h	;Portadresse fuer Bankumschaltung
;
	org	SCPROM
;------------------------------------
; Kennung ROM-Erweiterung und
; Initialisierungsadressen
;
	defm	'AB'		;Kennzeichen
	defw	R8INI		;Adr. Initialisierung
	defw	0		;Eintritt CALL
	defw	0		;         Aufruf Zusatzger.
	defw	0		;RAM-Reservierung
	defw	0
	defw	0
	defw	0
;------------------------------------
*H ZG.S (Ludewig)
*I 7/ZG.S			;Bei Aenderungen ROM-BIOS aendern !!!
*E
;------------------------------------
R8INI	call	DBAABF		;Abfrage aktuelle Bank
	and	30h		;page 2
	ld	b,a
	ld	a,(SLCTRL)
	and	0CFh
	or	b
	ld	(SLCTRL),a	;auf akt. Slot-Nr.
	ld	hl,JPINSC
	ld	de,INSCPX
	ld	bc,8
	ldir
	ret
;
JPINSC	ld	a,(SLCTRL)
	out	(PPIA),a
	jp	CBOOT
;-------------------------------------------------------
*H BDOSSCP.ROM.S (Kersten)
*I 7/BDOSSCP.ROM.S ;BDOS-Rahmen fuer SCP
*H SCPLUE.S (Luetzner)
*I 7/SCPLUE.S
*H SCPELV.S (Elssner)
*I 7/SCPELV.S	;V24 PIO und SIO Treiber
*H SCPSCH.S (Schlegel)
*I 7/SCPSCH.S	;Warmstart
*H SCPSCH2.S (Schlegel)
*I 7/SCPSCH2.S	;BIOS-Verteiler fuer zeichenweise E/A-Geraete
*H SCPELO.S (Elssner)
*I 7/SCPELO.S	;CCP-Initialisierung und Kommandointerpreter
*H SCPELK.S (Elssner)
*I 7/SCPELK.S	;CCP-residente Kommandos
*H SCPELA.S (Elssner)
*I 7/SCPELA.S	;CCP-Kopie des RAM
*H SCPLOE.S (Loeber)
*I 7/SCPLOE.S	;Kaltstart
*H SCPMUE.S (Mueller)
*I 7/SCPMUE.S
;
	COND	$.UGT.0A000H
	Ueberlauf SCPROM !
	ENDC
*H RAM
RSOLO	EQU	0		;RAM nicht allein
DSE	equ	1
DSE1RA	equ	1
DSE2RA	equ	1
DISKLU	EQU	0		;BICDITR nicht enthalten
SCP	equ	1
ELS	EQU	1		;SCPEL* enthalten
*L OFF
*I 7/BICRAM.S
*L ON
;*******************************************************
