;*******************************************
;!HEAD MODULE
;FILE		BDOS.RAM.S
;DISK		
;AUTHOR		Kersten -> Ludewig
;DATE		10.05.89
;VARIABLES	(hier nicht aufgefuehrt)
;END
;!
; File enthaelt den bei RBASIC und SCP   i m m e r   benoetigten RAM-Teil
;
;*******************************************
;
BBDOS:	DEFS 3	;JP	BDOS1	;BDOS-Eintritt Disk-BASIC
;
;===========================================
;; Fehlerreaktionsadressen (bei BASIC alle BFMELD)
;
BADSEC:	 DEFS 2	;DEFW	SBSEC	; Bad sector (RAM)
BADSEL:	 DEFS 2 ;DEFW	SBSEL	; Bad select (RAM)
DISKRO:	 DEFS 2 ;DEFW	SDRO	; Disk R/O   (RAM)
FILERO:	 DEFS 2 ;DEFW	SFRO	; File R/O   (RAM)
;
ie34a	DEFS	5		;Hilfsprogramm Fehlerbehandlung
;	ld	e,(hl)
;	inc	hl
;	ld	d,(hl)
;	ex	de,hl
;	jp	(hl)            ; Ansprung Fehlerbehandlung
;===========================================
BDV0:	defs	1
BDV1:	defs	1
BDV2:	defs	1
BDV3:	defs	1
;-------------------------------
USTACK:	DEFS	2		; Rettung Anwender-STACK
	defs	80*2		; BDOS-STACK
STACK:
;-------------------------------
USER:	defs	1
CURRD:	defs	1		;aktuelles laufwerk
DEPARM:	DEFS	2 		; Input-Parameter
HLPARM:	DEFS	2 		; Return-Parameter
;
HILFV1:	 DEFS	2		; Hilfsvariable 1
HILFV2:	 DEFS	2		;               2
;
BDMA	DEFS	80H
*EJEC
ERASE:	defs	1 ; defb 0e5h
ROVEKT:	DEFS	2		;r/o vector (bei reset disk auf 0)
LOGVEKT:DEFS	2		;login-vector ( " )
DMAADD:	DEFS	2 ; defw 80h	;(bzw. = BDMA bei BASIC)
STDDMA:	DEFS	2 ; defw 80h	;(bzw. = BDMA bei BASIC)
;-------------------------------
; kopie der disk-parameter fuer aktuelles laufwerk
ADJOB1:	DEFS	2		;adr(dphwork1) akt dir-entries
ADJOB2:	DEFS	2		;adr(dphwork2) rel track zu offset
ADJOB3:	DEFS	2		;adr(dphwork3) rel sector zu offset
ADDIR:	DEFS	2		;adr(dirbuf)
ADDPB:	DEFS	2		;adr(dph)
ADCHECK:DEFS	2		;adr(checksvectortable)
ADALLOC:DEFS	2		;adr(alloc)
CSPT:	DEFS	2		;sectors per track
CBSH:	defs	1		;block shift
CBLM:	defs	1		;block mask
CEXM:	defs	1		;extnt mask
CDSM:	DEFS	2		;disk size  -1
CDRM:	DEFS	2		;dirmax  -1
CAL12:	DEFS	2 ; DFB	0,0	;alloc 0,1
CCKS:	DEFS	2		;checksize
COFF:	DEFS	2		;offset
ADXLT:	DEFS	2		;adr(translatetable)
;-------------------------------
dedd2:	defs	1
RWMODE:	defs	1
dedd4:	defs	1
SRMODE:	defs	1
ENTBYTE:defs	1
dedd7:	defs	1
NMBSRCH:defs	1
ENTFCB:	DEFS	4 ; DFB	0,0,0,0
BLOCK:	defs	1
IFDISK:	defs	1		;<>0, wenn fcb[0] veraendert
OLDDISK:defs	1 ; defb 0ffh	;keller curdsk
FCB_0:	defs	1		;gerett. fcb[0]
COUNTR:	defs	1
EXTMAS:	defs	1
RECORD:	DEFS	2
NMBREC:	DEFS	2
dede7:	DEFS	2
FCBOFFS:defs	1		;direntry*32
NMBDIR:	DEFS	2		;akt. dir-nr
dedeb	equ	NMBDIR+1
dedec:	DEFS	2
SYSDV:	defs	1 ; defb 0   	;kaltstart-laufwerk, bei disk-reset ausgewaehlt
				;   (hier = A)
; ---------------- Ende BDOS.RAM.S ---------
