;*******************************************
;!HEAD MODULE
;FILE		BDOSSCP.RAM.S
;DISK		
;AUTHOR		Kersten -> Ludewig
;DATE		09.05.89
;VARIABLES	(hier nicht aufgefuehrt)
;END
;!
; File enthaelt den nur fuer SCP benoetigten RAM-Teil
; (D.h. den BDOS-Rahmen. Wird aus ROM geladen.)
;*******************************************
;
SBDOS:	DEFS 3			;JP SBDOS0 ; BDOS-Eintritt SCP (i. RAM)
;===========================================
SBDSEC:	DEFS 2			;DEFW	ERRBAD
SBDSEL:	DEFS 2			;DEFW	ERRSEL
SDISKRO:DEFS 2			;DEFW	ERRDRO
SFILERO:DEFS 2			;DEFW	ERRFRO
;===========================================
	DEFS	13		; BWS-Vorsatz
;===========================================
SBDOS0:	DEFS	24		; Bank-Umschaltung, Ansprung ROM-BDOS
;
;SBD1	LD	(UST0),SP	; Retten  SP
;	LD	SP,STACK0	; Ist erforderlich, da User-Stack
;				; nur Platz fuer 1xCALL zu haben
;				; braucht.
;	IN 	A,(PPIA) 	; ( zugehoerige RAM-Adr. = SBDOS0 )
;	LD	(RettMem),A 	; Retten Speicherbelegung
;	LD	A,(SLCTRL)	; SCPX-Bank-Belegung mit SCP-RAM
;	AND	0FCh		;  0 bis 0FFh auf Bank 2
;	OR	2
;	OUT	(PPIA),A
;	JP	SBDOS1		; Sprung zu ROM-BDOS
;===========================================
SBDOSE	DEFS	20
;	
;SBD01:	LD	SP,(UST0)	;SBDOSE: Endebehandlung fuer SCP-BDOS
;	LD	DE,(RettDE)
;	LD	(RettA),A
;	LD	A,(RettMem)
;	OUT	(PPIA),A
;	LD	A,(RettA)
;	RET
;SBD2:
;
;*******************************************
;; Sprung zur Fehlerbehandlung im SCP-Vorspann
;   (RAM liegt im RBASIC parallel zu FNDBUF !)
;
;SBSEC	DEFS	5				! s. FNDBUF !
;SSBSEC:ld	hl,SBDSEC
;	jr	Sbder
;-------------------------------------------
;SBSEL	DEFS	5				! s. FNDBUF !
;SSBSEL:ld	hl,SBDSEL
;	jr	Sbder
;-------------------------------------------
;SDRO	DEFS	5				! s. FNDBUF !
;SSDRO:	ld	hl,SDISKRO
;	jr	Sbder
;-------------------------------------------
;SFRO	DEFS	3				! s. FNDBUF !
;SSFRO:	ld	hl,SFILERO
;-------------------------------------------
;Sbder	DEFS	7				! s. FNDBUF !
;SSbder	LD	A,0AAH
;	OUT	(PPIA),A
;	jp	ie34a
;===========================================
;ERRBAD	DEFS	25				! s. FNDBUF !
;
;SERRBAD:ld	hl,MBad		;bad sector
;	LD	A,(SLCTRL)
;	AND	0FCH
;	OR	2
;	OUT	(PPIA),A
;	call	SFMELD 		; Aufruf Fehlerbehandlg.
;	cp	03h
;	ret	nz
;	LD	A,0AAH
;	OUT	(PPIA),A
;	JP	0
;-----------------------
;ERRSEL	DEFS	5				! s. FNDBUF !
;SERRSEL:ld	hl,MSel		;select
;	jr	ERRRES
;-----------------------
;ERRDRO	DEFS	5				! s. FNDBUF !
;SERRDRO:ld	hl,MRO		;r/o
;	jr	ERRRES
;-----------------------
;ERRFRO	DEFS	3				! s. FNDBUF !
;SERRFRO:ld	hl,MFRO		;file r/o
;-----------------------
;ERRRES	DEFS	19				! s. FNDBUF !
;SERRRES:LD	A,(SLCTRL)
;	AND	0FCH
;	OR	2
;	OUT	(PPIA),A
;	call	SFMELD
;	LD	A,0AAH
;	OUT	(PPIA),A
;	jp	0
;===========================================
;
;; BDOS-Fehlermeldungen ( ->RAM)
;
;MERR0	DEFS	12				! s. FNDBUF !
;	defm	'BDOS err on ' 	;werden aus ROM geladen
;MERR1	DEFS	4				! s. FNDBUF !
;	defm	' : $'          ;dort MERR00 u. MERR10
;*******************************************
;(RAM liegt im RBASIC parallel zu FIRERL !)
;
;RettDE:DEFS	2				! s. FIRERL !
;RettA:	DEFS	1				! s. FIRERL !
;RettMem:DEFS	1				! s. FIRERL !
;*******************************************
;   (RAM liegt im RBASIC parallel zu ACTZN !)
;
;UST0:	DEFS	2				! s. ACTZN !
;	DEFS	10*2
;STACK0:	 				! s. ACTZN !
;-----------------------
;ZFCB:	DEFS	36             	;Zwischenpuffer fuer FCB's		! s. ACTZN !
;DZRET	DEFS	3		;Direktzugriffsparameter (r0..r2)	! s. ACTZN !
STRLEN	EQU	258
;ZSTR:	DEFS	STRLEN+1	;Zwischenpuffer fuer Strings (getrennt	! s. ACTZN !
				; wegen BDOS-Ruf 18 !!!)
;
; ------------- Ende BDOSSCP.RAM.S ---------
