;*******************************************
; RAM fuer Formatieren
;
; Stand: 09.05.89
;
; File: BICFORAM.S
;*******************************************
LWOK	EQU	EDIBUF	;<>0 nach LW-Eigabe
HDPBOP	EQU	LWOK+1	;Merkzelle Verify-Status
ASZEH:	EQU	HDPBOP+1
ASEIN:	EQU	ASZEH+1
KLZ:	EQU	ASEIN+1	;Blockzaehler bei Kontrollesen
TRACK:	EQU	KLZ+1	;Zaehler f.noch zu format.Spuren
SPFWDH:	EQU	TRACK+1	;Wdh.-versuche zum Form.einer Spur (nach Status-
			;fehlern vom Modul 'bifm')
SFWDH:	EQU	SPFWDH+1;Wdh.-versuche zum Form.eines Sektors (nach Fehlern
			;beim sektorweisen Kontrollesen)
VRM:	EQU	SFWDH+1	;Unterscheidung Vorder-/Rueckseite d.Disk
SFM:	EQU	VRM+1	;Merker f.fehlerhafte 128-Byte-Sek.beim Kontrollesen
DEFBL:	EQU	SFM+1	;Zwischenspeicher f.def.-Blocknr.
BLZEIG:	EQU	DEFBL+2	;Zeiger auf naechste freie Zelle des DBM
DBLLGE:	EQU	BLZEIG+2;max.Laenge des DBM
			;16 Byte lang --> 8 2-K-Bloecke = 1 Extent
;Schnittstellen f.RD/WR und Form
;-------------------------------------------
SCHNR:	EQU	DBLLGE+1;(ix+ 0)	Befehl
			;(ix+ 1)	Laufwerk
			;(ix+ 2)	Spur
			;(ix+ 3)	Kopf
			;(ix+ 4)	Sektor
			;(ix+ 5)	rel.Datenfeldlaenge
			;(ix+ 6)	Gap 3
			;(ix+ 7)	Sektoranzahl
			;(ix+ 8)	Verfahren (FM/MFM)
			;(ix+ 9)	Schritte/Spur
PUFFR:	EQU	SCHNR+10;(ix+10)	Puffadr.(low)
			;(ix+11)	Puffadr.(high)
			;(ix+12)	DRPB (low)
			;(ix+13)	DRPB (high)
			;(ix+14)	Status
;
SCHNF:	EQU	PUFFR+5	;(ix+ 0)	Befehl
			;(ix+ 1)	Laufwerk
			;(ix+ 2)	Spur
			;(ix+ 3)	Kopf
			;(ix+ 4)	Sektorinhalt
			;(ix+ 5)	rel.Datenfeldlaenge
			;(ix+ 6)	Gap 3
			;(ix+ 7)	Sektoranzahl
			;(ix+ 8)	Verfahren (FM/MFM)
			;(ix+ 9)	Schritte/Spur
PUFFF:	EQU	SCHNF+10;(ix+10)	Puffadr.(low)
			;(ix+11)	Puffadr.(high)
			;(ix+12)	DRPB (low)
			;(ix+13)	DRPB (high)
			;(ix+14)	Status
;-------------------------------------------
;Puffer f.ID-Felder:
;-------------------
F3H0:	EQU	PUFFF+5		;C,H,R,N f.Sektor 1,Kopf 0,Spur 0 (C wird bei
				;	   Sektor 4 /jedem Aufruf aktualisiert)
				;		  2
				;		  5	
				;		  3
F3H1:	EQU	F3H0+20		;C,H,R,N f.Sektor 1,Kopf 1,Spur 0 (s.oben)
;
;Bereich zum Anlegen der Sperrdatei
;----------------------------------
ERRFIL	EQU	F3H1+20		;User 17
				;errfile.sav mit gesetztem Bit 7 im Typ
EXTZA	EQU	ERRFIL+12	;Extentzaehler (hier 0)
				;Byte 13/14 des Dir.-Eintrages
RECC	EQU	EXTZA+3		;Zaehler f.die belegten 128-Byte-Saetze (0..80h)
DBM	EQU	RECC+1		;Merker f.defekte Bloecke (zum Anlegen v.'errfile.sav')
DBMEND	EQU	DBM+15		;letztes Byte von DBM
;*******************************************
