	ORG	0C000H-7
;***************************************
; PLOTTERINITIALISIERUNG
; PATCH-RUFE EINTRAGEN
; STAND: 28.11.89 / WEITZMANN
;***************************************
	GLOBAL	PLINIT
;=======================================
        EXTERNAL  AC1IHL
	EXTERNAL  BYTAE2
        EXTERNAL  CDBL
        EXTERNAL  CINT
        EXTERNAL  ERFC
        EXTERNAL  ERSN
        EXTERNAL  INKUP
        EXTERNAL  INKUEB
        EXTERNAL  MLT4
        EXTERNAL  MLT8HL
        EXTERNAL  SNAL3
        EXTERNAL  TCHAR0
        EXTERNAL  XYUEB
;---------------------------------------
ABS     EQU	2B02H
ADD4    EQU     2ECEH
COLT5   EQU     7818H
CPSTX   EQU     8
CSNG    EQU     2C32H
DIV4    EQU     2EE7H
DIV8HL  EQU     28C1H
SCREUP  EQU     7940H
TCHAR   EQU     10H
TCHAR1  EQU     4650H
TVORZ   EQU     2AF1H
;=======================================
AUKO    EQU     30A5H
CPREG	EQU 	20H
INBV24	EQU	8C71H
PPIA  	EQU	0A8H
V24SP	EQU	8CD1H
;=======================================
	DEFB	0FEH
	DEFW	PLINIT          ;ANFANGSADRESSE
	DEFW	ENDE            ;ENDADRESSE
	DEFW	PLINIT		;STARTADRESSE
PLINIT:	LD	(STACK),SP
	LD	SP,STACK
	IN	A,(PPIA)
	PUSH	AF
	LD	A,(SLCTRL)
	OUT	(PPIA),A
	CALL	INBV24 	 	;V.24-INIT.
	POP	AF
	OUT	(PPIA),A
	LD	SP,(STACK)
        CALL	PLPAIN		;PATCHRUFE EINTRAGEN
	LD	HL,HPGL
	PUSH	HL
	LD	(HL),'I'
	INC	HL
	LD	(HL),'N'
	INC	HL
	LD	(HL),3BH
	INC	HL
	LD	(HL),0		;ENDEKENNZEICHEN
	POP	DE              ;HPGL-ANFANG
	CALL	V240 		;INIT. PLOTTER
	RET
;
PLPAIN:	LD	HL,PLOPAT
	LD	BC,0
PLPAI1:	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	INC	HL
	LD	A,E
	OR	D
	RET 	Z		;FERTIG
	EX	DE,HL
	LD	(HL),0C3H
	INC	HL
	EX	DE,HL
	LDI               	;ADRESSE
	LDI
	LD	A,0C9H		;RETURN
	LD	(DE),A
	JR	PLPAI1
;
PLOPAT:	DEFW	XSCREN
	DEFW	SCREN0
	DEFW	XPSET
	DEFW	PSET0
	DEFW	XLINE
	DEFW	LINE0
	DEFW	XPAINT
	DEFW	PAINT0
	DEFW	XCIRCL
	DEFW	CIRC0
	DEFW	XPOINT
	DEFW	POINT0
	DEFW	XDRAW
	DEFW	DRAW0
	DEFW	XCOLOR
	DEFW	COLOR0
	DEFW	XWINDO
	DEFW	WINDO0
	DEFW	0
;
;***************************************
; BASIC-ROUTINEN FUER PLOTTERERWEITERUNG
; Stand: 28.11.89 / Weitzmann
;***************************************
; PSET / PRESET      		
;---------------------------------------
PSET0:	CALL	SCRUP
	RET	NZ
        PUSH	AF		;WOHER ?
      	LD	DE,BUF     	
	PUSH	DE
	CALL 	XYPARU
      	CALL    FARBE           ;FARBE ABSPEICHERN
	POP	DE
	POP	AF		;WOHER ?
	JR	C,PSET1	 	;PSET
	LD	C,1		;PSET
	JR	PSET2
PSET1:	LD	C,5		;PRESET
PSET2:	JP	HLRET
;=======================================
; LINE
;---------------------------------------
LINE0:	CALL	SCRUP
	RET	NZ
      	LD	DE,BUF
	PUSH	DE
	LD	A,(HL)
	CP	0F2H		;MINUSTOK?
	JR	Z,LINE1		;JA
	CALL	XYPARU		;1. PARAMETERPAAR IN BUF
	LD	A,(HL)
	CP	0F2H		;MINUSTOK?
	JP	NZ,ERSN		;NEIN, SYNTAXFEHLER
	JR	LINE2
LINE1:	XOR	A
	LD	(DE),A
	INC	DE		;A=0, WENN KOORD. NICHT VORH.
	INC	DE		;) ZEIGER
	INC	DE		;) 4 PLAETZE
	INC	DE              ;) WEITER
        INC     DE              ;) IN BUF
LINE2:  CALL    TCHAR0          ;NAECHST. SIGN. ZEICHEN
      	CALL	XYPARU		;2. PARAMETERPAAR IN BUF
	CALL    FARBE
	JR	Z,LINE4		;OHNE BF
	LD	B,1
	RST	CPSTX
	DEFB	','             ;KOMMA
	RST	CPSTX
     	DEFB    'B'		;BOX
	JR	Z,LINE3		;B VORH., ZEILENENDE
	INC	B               ;B=2, BF
	RST	CPSTX
	DEFB	'F'		;BF
LINE3: 	LD	A,B
	JR	LINE5
LINE4: 	XOR	A		;A=0, BF NICHT VORH.
LINE5: 	LD	(DE),A
	POP	DE
	LD	C,2		;KENNZAHL
	JP	HLRET
;=======================================
; CIRCLE
;---------------------------------------
CIRC0:	CALL	SCRUP
	RET	NZ
      	LD	DE,BUF
	PUSH	DE
	CALL	XYPARU
	RST	CPSTX		;OHNE RADIUS SN-ERROR
	DEFB	','
	PUSH	DE              ;BUF
	CALL	SNAL3 		;RADIUS UEB.
        PUSH    HL              ;QUELLE
        CALL    CDBL
        LD      HL,SCALEX
        CALL    MLT8HL
        CALL    CINT            ;RADIUS IN HL (INTEGER)
        EX      DE,HL           ;DE: RADIUS
	POP     BC              ;QUELLZEIGER
	POP     HL              ;BUF-ZEIGER
	CALL	PARU1		;RADIUS IN BUF
        EX      DE,HL
        PUSH    BC
        POP     HL              ;QUELLZEIGER
	CALL    FARBE
	PUSH	DE              ;BUF-ZEIGER
        XOR     A               ;VORZEICHEN +
        LD      (VORWI),A
        LD      DE,0            ;STANDARD-ANFANGSWINKEL
        CALL    UEBWI
        EX      (SP),HL         ;HL:BUF-ZEIGER, SP:QUELLE
        LD      A,(VORWI)
        LD      (HL),A
        INC     HL
        CALL    PARU1           ;ANFWINKEL IN BUF
        EX      (SP),HL         ;HL:BUF-ZEIGER
        XOR     A
        LD      (VORWI),A
        LD      DE,0168H        ;STANDARD-ENDWINKEL, 2*PI
        CALL    UEBWI
        EX      (SP),HL         ;HL:BUF-ZEIGER, SP:QUELLE
        LD      A,(VORWI)
        LD      (HL),A
        INC     HL
        CALL    PARU1           ;ENDWINKEL IN BUF
        EX      (SP),HL         ;HL:BUF-ZEIGER
        DEC     HL
        CALL    TCHAR0
        JR      Z,CIRC2         ;BEI ZEILENENDE
        RST     CPSTX
        DEFB    ','
        CALL    SNAL3           ;AUSDRUCK ELLI.PAR. AUSWERTEN
        PUSH    HL
        CALL    CDBL
        CALL    TVORZ
        JP      Z,ERFC          ;ELLI=0
        JP      M,ERFC          ;ELLI NEGATIV
        LD      HL,SCALEY
        CALL    MLT8HL
        LD      HL,SCALEX
        CALL    DIV8HL
        CALL    ABS
        CALL    CSNG
        POP     HL              ;QUELLE
        EX      (SP),HL         ;HL:BUF-ZEIGER
        LD      DE,AC1
        LD      B,4
CIRC1:  LD      A,(DE)
        LD      (HL),A          ;ELLI IN BUF
        INC     HL
        INC     DE
        DJNZ    CIRC1
        JR      CIRC3
CIRC2:  EX      (SP),HL
        LD      DE,1            ;ELLI NICHT VORHANDEN
        CALL    PARU1           ;STANDARD-ELLI IN BUF
CIRC3:  POP     HL              ;QUELLE
        POP     DE              ;BUF-ANFANGSZEIGER
        LD      C,3             ;KENNZAHL
        JP      HLRET
;
UEBWI:  DEC     HL              ;WINKELPARAMETER UEBERNEHMEN
        RST     TCHAR
        RET     Z               ;KEIN WEITERES ZEICHEN
        RST     CPSTX
        DEFB    ','
        CP      ','
        RET     Z               ;KEIN WINKEL --> STANDARDWERT
        PUSH    BC
        CALL    SNAL3           ;AUSDRUCK AUSWERTEN
        EX      (SP),HL
        PUSH    HL
        CALL    CSNG
        POP     BC
        LD      HL,AC1
        LD      A,(HL)
        OR      A
        JP      P,UEBWI1        ;VORZEICHEN + --> KEINE KREISSEKTORLINIE
        AND     7FH             ;VORZEICHEN -
        LD      (HL),A          ;WINKEL + EINTRAGEN
        LD      A,1
        LD      HL,VORWI
        LD      (HL),A
UEBWI1: LD      BC,5742H        ;180/PI UMRECHNUNG BOGENMASZ
        LD      DE,5829H        ;IN GRADMASZ
        CALL    MLT4
        LD      BC,0041H
        LD      DE,0010H
        CALL    ADD4            ;ADDITION VON 0.01
        CALL    CINT            ;GRADMASZ IN HL
        POP     DE
        EX      DE,HL           ;DE;GRADMASZ, HL:QUELLE
        RET
;=======================================
; PAINT
;---------------------------------------
PAINT0:	CALL	SCRUP
	RET	NZ
       	LD	DE,BUF
	PUSH	DE
	CALL	XYPARU
	CALL    FARBE
       	CALL    FARBE
	POP	DE
	LD	C,4		;KENNZAHL
	JP	HLRET
;=======================================
; POINT
;---------------------------------------
POINT0:	CALL	SCRUP
	RET	NZ
	DEC	HL
POINT1:	RST	TCHAR 		;HL AUF ENDEZEICHEN
	JR	NZ,POINT1 	;VON QUELLE
	RET                     ;KEINE REAKTION
;=======================================
; WINDOW
;---------------------------------------
WINDO0: CALL	SCRUP
	RET	NZ
	RET
;=======================================
; DRAW
;---------------------------------------
DRAW0:	CALL	SCRUP
	RET	NZ
	RET
;=======================================
; COLOR
;---------------------------------------
COLOR0:	CALL	SCRUP
	RET	NZ
	LD	DE,COLT5
	EX	DE,HL
	EX	(SP),HL
	EX	DE,HL
	RET
;=======================================
; SCREEN
;---------------------------------------
SCREN0:	CALL	SCREUP		;SCREEN-NR. NACH A
	CP	6
	DEC	HL
	RET	NZ
	LD	DE,SCRNRA
	LD	(DE),A
	RST	TCHAR
	POP	DE
	RET	Z
	JP	ERFC
;=======================================
;
SCRUP:  LD	DE,SCRNRA
	LD	A,(DE)
	CP	6
	RET
;
PARU2:  LD      (HL),C
	INC	HL
	LD	(HL),B
	INC	HL
PARU1:  LD      (HL),E
        INC     HL
        LD      (HL),D
        INC     HL
	RET
;
XYPARU: PUSH    DE              ;(X,Y)-PARAMETER UEBERNEHMEN
        CALL    XYUEB
        EX      (SP),HL
	CALL	PARU2
	EX      (SP),HL
        POP     DE
	RET
;
FARBE:  CALL    INKUP           ;FARBPAR. BZW. STANDARDF. IN ACTINK
       	PUSH	BC
	PUSH	DE
	DEC	HL
	RST	TCHAR
	JR	Z,FARBE1
	RST	CPSTX
	DEFB    ','
	CP	','
	JR	Z,FARBE1
	CALL	BYTAE2 	 	;FARBE IN A UND E
	LD	(ACTINK),A
FARBE1: POP	DE
	POP	BC
	CALL	TCHAR1
	PUSH	AF
        LD      A,(ACTINK)
        LD      (DE),A
        INC     DE
	XOR	A
	LD	(DE),A		;2.BYTE EINTRAGEN
	INC	DE
	POP	AF
        RET
;
HLRET:  EX      (SP),HL
        CALL    TREIB
        POP     HL              ;HL AUF ENDEZEICHEN VON QUELLE, (00)
        RET
;
;*****************************************
; ROUTINEN ZUR HPGL-SCHNITTSTELLE
; STAND: 06.12.89 / Weitzmann
;*****************************************
TREIB:  PUSH   DE
        LD     HL,HPGL          ;PUFFER FUER HPGL-SCHNITTSTELLE
        LD     A,C              ;KENNBYTE
        CP     1
        JP     Z,TPSET
        CP     2
        JP     Z,TLINE
        CP     3
        JP     Z,TCIRCL
        CP     4
        JP     Z,TPAINT
        CP     5
        JP     Z,TPRESE
        CP     6
        JP     Z,TCOLOR
        CP     8
        JP     Z,TWINDO
        CP     9
        JP     Z,TDRAW
;=======================================
; PSET
;---------------------------------------
TPSET:  LD     DE,BUF+4
        CALL   TCOLOR
        CALL   PULAD
	LD     (HL),3BH
	INC    HL
        CALL   PALAD
        POP    DE		;BUF-ZEIGER, ANFANG
        CALL   XYLAD
        CALL   PDLAD
	LD     (HL),3BH
	INC    HL
        CALL   PULAD
	LD     (HL),3BH
	INC    HL
	LD     (HL),0
        JP     TREIB1
;=======================================
; LINE
;---------------------------------------
TLINE:	LD	DE,BUF+8
	CALL	TCOLOR
	CALL	PULAD
	LD      (HL),3BH
	INC     HL
	CALL	PALAD
	POP	DE              ;HL:HPGL, DE:BUF
	CALL	XYLAD		;1.PARAMETERPAAR
	PUSH	DE
	LD	DE,BUF+10
	LD	A,(DE)
	AND	A
	JP	Z,TLINE1 	;B=0, LINIE
	CP	1
	JP	Z,TLINE2	;B=1, BOX
	LD	(HL),'F'	;B=2, BOX FILL
	INC	HL
	LD	(HL),'T'
	INC	HL
	LD      (HL),3BH
	INC     HL
	LD	(HL),'R'
	INC	HL
	LD	(HL),'A'
	INC	HL
	POP	DE		;BUF-ZEIGER
	CALL	XYLAD		;2.PARAMETERPAAR
	CALL	PALAD
        JP	TLINE3
TLINE1:	CALL	PDLAD		;LINIE
	LD      (HL),3BH
	INC     HL
	CALL	PALAD
	POP	DE		;BUF-ZEIGER
	CALL	XYLAD		;2.PARAMETERPAAR
	CALL	PULAD
	LD      (HL),3BH
	INC     HL
	JP	TLINE4
TLINE2:	LD	(HL),'E'	;BOX
	INC	HL
	LD	(HL),'A'
	INC	HL
	POP	DE              ;BUF-ZEIGER
	CALL	XYLAD		;2.PARAMETERPAAR
	CALL	PALAD
TLINE3:	LD	DE,BUF+4
	CALL	XYLAD		;LP EINSTELLEN
TLINE4: LD      (HL),0
	JP      TREIB1
;=======================================
; CIRCLE
;---------------------------------------
TCIRCL: LD	IX,(BUF)
       	LD	DE,BUF+6
	CALL	TCOLOR
	CALL	PULAD
	LD	(HL),3BH
	INC	HL
	CALL	PALAD
	PUSH	HL		;HPGL-ADR.
	LD	DE,BUF+14
	LD	A,(DE)
	CP	1
	JP	NZ,TCIELL	;ELLIPSE
	LD	DE,(BUF+9)      ;ANFWI
	LD	HL,0
	RST	CPREG
	JR	NZ,TCIRC1	;KEIN STANDARDWINKEL
	LD	DE,(BUF+12)	;ENDWI
	LD	HL,0168H 	;2*PI
	RST	CPREG
	JR	Z,TCIRC0	;KREIS
	LD	DE,BUF+11	;VORZ. ENDWI
	LD	A,(DE)
	AND	A
	JP	Z,TCIRC2	;BEIDE WINKEL POS.
	JP	TCIRC3		;WINKEL POS./NEG.
TCIRC1: LD	DE,BUF+8	;VORZ. ANFWI
	LD	A,(DE)
	AND	A
	JR	Z,TCIRC5
	LD	DE,BUF+11
	LD	A,(DE)
	AND	A
	JP	Z,TCIRC3	;WINKEL POS./NEG.
	JP	TCIRC4		;BEIDE WINKEL NEG.
TCIRC5:	LD	DE,BUF+11
	LD	A,(DE)
	AND	A
	JR	Z,TCIRC2	;WINKEL POS.
	JP	TCIRC3
TCIRC0:	POP	HL 		;KREIS
	POP	DE
	CALL	XYLAD		;KOORD. UEB.
	LD	(HL),'C'
	INC	HL
	LD	(HL),'I'
	INC	HL
	CALL	XLAD		;RADIUS UEB.
	JP	TCIRC6
TCIRC2:	POP	HL    		;WINKEL POS.
	LD	DE,(BUF)
	CALL	XRAD		;X+RADIUS
	CALL	XYLAD		;XY-KOORD.
	LD	(BUF),IX
	CALL	BOGEN
	LD	DE,BUF+9	;ANFWI
	CALL 	XLAD
	CALL	PDLAD
	LD	(HL),3BH
	INC	HL
	CALL	BOGEN
	CALL	DIFWI
	CALL	PULAD
	LD	(HL),3BH
	INC	HL
	CALL	PALAD		;LP EINSTELLEN
	POP	DE
	CALL	XYLAD
	JP	TCIRC6
TCIRC3:	POP	HL 		;WINKEL POS./NEG.
	LD	DE,(BUF)
	CALL	XRAD
	CALL	XYLAD
	LD	(BUF),IX
	CALL	BOGEN
	LD	DE,BUF+8	;VORZ. ANFWI
	LD	A,(DE)
	AND	A               ;VORZ. ANFWI
	JR	NZ,TCIR31	;NEG. ANFWI
	INC	DE
	LD	A,2BH		;PLUS
	JR	TCIR32
TCIR31:	LD	DE,BUF+12	;ENDWI
	LD	A,2DH		;MINUS
TCIR32:	PUSH	AF
	CALL	XLAD
	CALL	PDLAD
	LD	(HL),3BH
	INC	HL
	CALL	BOGEN
	POP	AF    		;VORZEICHEN
	LD	(HL),A
	INC	HL
	CALL	DIFWI
	CALL	PALAD
	POP	DE
	CALL	XYLAD
	CALL	PULAD
	LD	(HL),3BH
	INC	HL
	JR	TCIRC6
TCIRC4:	POP	HL 		;WINKEL NEG.
	POP	DE
	CALL	XYLAD 		;KOORD. UEB.
	LD	(HL),'E'
	INC	HL
	LD	(HL),'W'
	INC	HL
	CALL	XLAD		;RADIUS UEB.
	DEC	HL
	LD	(HL),2CH
	INC	HL
	LD	DE,(BUF+9)	;ANFWI
	CALL	XLAD		;ANFWI UEB.
	DEC	HL
	LD	(HL),2CH
	INC	HL
	CALL	DIFWI
	JP	TCIRC6
TCIELL:	RET
TCIRC6: LD	(HL),0
        JP	TREIB1
;
BOGEN:  LD	(HL),'A' 	;KREISBOGEN
	INC	HL
	LD	(HL),'A'
	INC	HL
	LD	DE,BUF
	CALL	XYLAD
	DEC	HL
	LD	(HL),2CH
	INC	HL
	RET
;
XRAD:   PUSH	HL 		;X-KOORD. + RADIUS
	LD	HL,(BUF+4)	;RADIUS
	ADC	HL,DE
	LD	DE,BUF
	LD	A,L
	LD	(DE),A
	INC	DE
	LD	A,H
	LD	(DE),A
	DEC	DE
	POP	HL
	RET
;
DIFWI:  PUSH	HL
	LD	HL,(BUF+12)	;ENDWI
	LD	DE,(BUF+9)	;ANFWI
	RST	CPREG
	JR	NC,DIFWI1	;ENDWI > ANFWI
	LD	BC,0168H	;360
	ADD	HL,BC		;360+ENDWI
DIFWI1: SBC	HL,DE 		;WINKEL-ANFWI
	LD	(DIWINK),HL
	LD	DE,DIWINK
	POP	HL
	CALL	XLAD
	RET
;=======================================
; PAINT / PRESET
;---------------------------------------
TPAINT:
TPRESE: CALL   PULAD
	LD     (HL),3BH
	INC    HL
        CALL   PALAD
        POP    DE
        CALL   XYLAD
	LD     (HL),0
        JP     TREIB1
;=======================================
; TCOLOR
;---------------------------------------
TCOLOR: LD      (HL),'S'
        INC     HL
        LD      (HL),'P'
        INC     HL
	CALL    XLAD
	RET
;=======================================
; WINDOW
;---------------------------------------
TWINDO: RET
;=======================================
; DRAW
;---------------------------------------
TDRAW:  RET
;=======================================
;
PULAD:  LD      (HL),'P'
        INC     HL
        LD      (HL),'U'
        INC     HL
        RET
;
PALAD:  LD      (HL),'P'
        INC     HL
        LD      (HL),'A'
        INC     HL
        RET
;
PDLAD:  LD      (HL),'P'
        INC     HL
        LD      (HL),'D'
        INC     HL
        RET
;
XYLAD:  CALL	LADE
	LD	(HL),2CH
	INC	HL
XLAD:	CALL	LADE
	LD	(HL),3BH
	INC	HL
	RET
;
LADE:   EX	DE,HL
	PUSH	DE
	LD	BC,2
	LD	A,C
        LD      (TYP),A
        LD      DE,AC1+2
        LDIR
        POP	DE 		;HPGL
        PUSH	HL
        PUSH	DE
	CALL	AUKO
	POP	DE         	;HPGL
LADE1:  LD	A,(HL)
	AND	A
	JR	Z,LADE2
	LD	(DE),A
	INC	HL
	INC	DE
	JR	LADE1
LADE2:  POP	HL
	EX	DE,HL		;DE:BUF, HL:HPGL
	RET
;
TREIB1: LD      DE,HPGL
V240:   LD      A,(DE)
	OR	A
	RET	Z               ;PUFFERENDE
	LD	C,A		;ZEICHEN IN C
	INC	DE
	PUSH	DE
	LD	(STACK),SP
	LD	SP,STACK
	IN	A,(PPIA)
	PUSH	AF
	LD	A,(SLCTRL)
	OUT	(PPIA),A
	LD	A,2
	CALL	V24SP
	POP	AF
	OUT	(PPIA),A
	LD	SP,(STACK)
	POP	DE
	JR	V240
;
	DEFS	30H
STACK:	DEFS	2
DIWINK:	DEFW	2
ENDE:
;*****************************************
