;!HEAD MODULE
;FILE		BIC.MAC.S
;DISK		BIC BDOS Arb.1
;AUTHOR		Kersten
;DATE		16.12.88
;VARIABLES	-
;END
;!
 
;; Blocktransfer
;  =============
 
; Aufruf z.B.:	MOVE 1000H (ADR) 128
 
MOVE:	MACRO	#ZIEL #QUELLE #LAENGE
	LD	DE,#ZIEL
	LD	HL,#QUELLE
	LD	BC,#LAENGE
	LDIR
	ENDM
 
;; Byte- bzw. Wort-Tabellen
;  ========================
 
; Makros erlauben pro Aufruf bis zu 10 Byte- bzw.
; Wort-Definitionen.
 
; Als Operanden nur Konstanten zulaessig!
 
; Aufruf z.B.:	DFB  17 35 0 -55H 001101B
;		(bei DFW entsprechend)
 
DFB:	MACRO	#0 #1 #2 #3 #4 #5 #6 #7 #8 #9
	DEFB	#0
	COND	'#1'
 DFB '#1' '#2' '#3' '#4' '#5' '#6' '#7' '#8' '#9'
	ENDC
	ENDM
 
DFW:	MACRO	#0 #1 #2 #3 #4 #5 #6 #7 #8 #9
	DEFW	#0
	COND	'#1'
 DFW '#1' '#2' '#3' '#4' '#5' '#6' '#7' '#8' '#9'
	ENDC
	ENDM
*EJEC
 
;; Fuellen RAM-Bereich mit einheitlichem Inhalt
;  ============================================
 
; Inhalt = sich lfd. wiederholende Folge von
; 1...8 Bytes (B0...B7)
 
; Fuer Operanden B0...B7 keine Register zulaessig
; (weder r noch (rr)!
 
; Aufruf z.B.:	FLRAM  (ADR) 1024 16 23H (BYTE1)
 
; aendert AF, BC, DE, HL
 
; Hilfs-Makro
 
FlRaM:	MACRO	#B0 #B1 #B2 #B3 #B4 #B5 #B6 #B7
	LD	A,#B0
	LD	(DE),A
	INC	DE
	DEC	BC
	COND	'#B1'
	FlRaM	'#B1' '#B2' '#B3' '#B4' '#B5' '#B6' '#B7'
	ENDC
	ENDM
 
; Haupt-Makro (fuer Anwender)
 
FLRAM:	MACRO	#ADRESSE #LAENGE #B0 #B1 #B2 #B3 #B4 #B5 #B6 #B7
;		ADRESSE = Anfangsadresse des zu
;			  fuellenden Bereiches
;		LAENGE  = Laenge des Bereiches
;		B0...B7 = sich wiederholende
;			  Byte-Folge
	LD	HL,#ADRESSE
	LD	D,H
	LD	E,L
	LD	BC,#LAENGE
 
	FlRaM	'#B0' '#B1' '#B2' '#B3' '#B4' '#B5' '#B6' '#B7'
 
	LDIR
 
	ENDM
;------------- Ende BIC.MAC.S ----------------
